{**********************************************}
{                                              }
{             FastReport v5.0                  }
{      NativeDB components design editors      }
{                                              }
{         Copyright (c) 1998-2014              }
{           by Fast Reports Inc.               }
{                                              }
{ Copyright (c) 2000-2014 by Stalker SoftWare  }
{                                              }
{**********************************************}

unit frxASAEditor;

interface

uses
  Windows, Classes, SysUtils, Forms, Controls, frxClass,
  frxCustomDB, frxDsgnIntf, DB, frxUtils, ndbBase, NdbAsa, frxRes
{$IFDEF Delphi6}
, Variants
{$ENDIF};

{$I frx.inc}

implementation

uses
  frxASAComponents;

type
  TfrxSessionProperty = class(TfrxComponentProperty)
  public
    procedure GetValues; override;
    procedure SetValue(const Value: String); override;
    function GetAttributes: TfrxPropertyAttributes; override;
  end; { TfrxSessionProperty }

{ TfrxSessionProperty }

function TfrxSessionProperty.GetAttributes: TfrxPropertyAttributes;
begin
 Result := [paMultiSelect, paValueList];
end; { GetAttributes }

procedure TfrxSessionProperty.GetValues;
var
  oList :TStringList;

begin

 Values.Clear;
 frxGetComponents(frComponent.Report, TAsaSession, Values, nil);

 oList := TStringList.Create;
 try
   frxGetComponents(frComponent.Report, TfrxAsaSession, oList, nil);
   Values.AddStrings(oList);
 finally
   FreeAndNil(oList);
 end; { try }

end; { GetValues }

procedure TfrxSessionProperty.SetValue(const Value: String);
var
  oComponent :TComponent;

begin

 if Value = '' then
   SetOrdValue(0)
 else begin

   oComponent := frxFindComponent(frComponent.Report, Value);

   if oComponent <> nil then
       SetOrdValue(Integer(oComponent))
   else
     raise Exception.Create(frxResources.Get('prInvProp'));
 end;

end; { SetValue }

initialization
  frxPropertyEditors.Register(TypeInfo(TAsaSession), TfrxAsaDataSet, 'Session', TfrxSessionProperty);

end.
